import { ScalarValue } from './types';
interface UsePositionConfig {
    x: ScalarValue;
    y: ScalarValue;
}
export declare function usePosition(config: UsePositionConfig): {
    x: number;
    y: number;
};
interface UseRectanglePositionConfig {
    x1: ScalarValue;
    y1: ScalarValue;
    x2: ScalarValue;
    y2: ScalarValue;
}
export declare function useRectanglePosition(config: UseRectanglePositionConfig): {
    x: number;
    y: number;
    width: number;
    height: number;
};
interface UseEllipsePositionConfig {
    cx: ScalarValue;
    cy: ScalarValue;
    rx: ScalarValue;
    ry: ScalarValue;
}
interface UseDirectedEllipsePositionConfig {
    x1: ScalarValue;
    y1: ScalarValue;
    x2: ScalarValue;
    y2: ScalarValue;
    width: ScalarValue;
}
export declare function useEllipsePosition(props: UseEllipsePositionConfig): {
    cx: number;
    cy: number;
    rx: number;
    ry: number;
};
export declare function useDirectedEllipsePosition(props: UseDirectedEllipsePositionConfig): {
    cx: number;
    cy: number;
    rx: number;
    ry: number;
    rotation: number;
};
export declare function usePointPosition(config: UsePositionConfig[]): string;
export declare function useIsSeriesVisible(id: string): boolean;
interface UseShiftOptions {
    xAxis: string;
    yAxis: string;
    xShift: ScalarValue;
    yShift: ScalarValue;
}
export declare function useShift(options: UseShiftOptions): {
    xShift: number;
    yShift: number;
};
export {};
