"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Shape = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const hooks_1 = require("../../hooks");
const Markers_1 = require("../Markers");
const shapes = {
    triangle: Triangle,
    circle: Circle,
    diamond: Diamond,
    square: Square,
};
function Triangle(props) {
    return (0, jsx_runtime_1.jsx)(Markers_1.Triangle, { size: props.size, style: props.style });
}
function Circle(props) {
    return (0, jsx_runtime_1.jsx)(Markers_1.Circle, { size: props.size, style: props.style });
}
function Diamond(props) {
    return (0, jsx_runtime_1.jsx)(Markers_1.Diamond, { size: props.size, style: props.style });
}
function Square(props) {
    return (0, jsx_runtime_1.jsx)(Markers_1.Square, { size: props.size, style: props.style });
}
function Shape(props) {
    const Figure = shapes[props.shape];
    if (!Figure) {
        throw new Error(`Invalid shape: "${props.shape}"`);
    }
    const { x, y } = (0, hooks_1.usePosition)({ x: props.x, y: props.y });
    return ((0, jsx_runtime_1.jsx)("g", { onMouseEnter: props.onMouseEnter, onMouseLeave: props.onMouseLeave, transform: `translate(${x}, ${y})`, children: (0, jsx_runtime_1.jsx)(Figure, { size: props.size, style: { fill: props.color, ...props.style } }) }));
}
exports.Shape = Shape;
