"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tick = exports.Ticks = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
function Ticks(props) {
    const { primaryTicks, getPositions, secondaryTickLength, scale, secondaryTickStyle, style, ...otherProps } = props;
    // Primary Ticks
    let elements = primaryTicks.map((tick) => {
        const { line, text } = getPositions(tick.position);
        return ((0, jsx_runtime_1.jsx)(Tick, { line: line, style: style, text: text, ...otherProps, children: tick.label }, tick.position));
    });
    if (secondaryTickLength !== 0) {
        // generate secondaryTicks according to the density of primaryTicks
        const range = Math.abs((scale === null || scale === void 0 ? void 0 : scale.range()[1]) - (scale === null || scale === void 0 ? void 0 : scale.range()[0])) || 0;
        const mainTicksDensity = range / primaryTicks.length;
        const density = mainTicksDensity < 50 ? 5 : 10;
        let secTicks = (scale === null || scale === void 0 ? void 0 : scale.ticks(primaryTicks.length * density)) || [];
        // add secondaryTicks to the elements array
        const secElements = secTicks.map((tick) => {
            // exclude the main ticks
            if (primaryTicks.map((tick) => tick.position).includes(scale(tick))) {
                return null;
            }
            const { line, text } = getPositions(scale(tick), true);
            return ((0, jsx_runtime_1.jsx)(Tick, { line: line, text: text, secondary: true, style: secondaryTickStyle, ...otherProps }, String(tick)));
        }) || [];
        elements = [...secElements, ...elements];
    }
    return (0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: elements });
}
exports.Ticks = Ticks;
function Tick(props) {
    const { line: { x1: lineX1 = 0, x2: lineX2 = 0, y1: lineY1 = 0, y2: lineY2 = 0 }, text: { x1: textX1 = 0, y1: textY1 = 0 }, children, strokeColor = 'black', strokeHeight = 1, anchor = 'end', secondary = false, labelStyle, style, dominantBaseline = 'middle', } = props;
    return ((0, jsx_runtime_1.jsxs)("g", { children: [(0, jsx_runtime_1.jsx)("line", { x1: lineX1, x2: secondary && lineX1 !== lineX2 ? lineX2 * strokeHeight : lineX2, y1: lineY1, y2: secondary && lineY1 !== lineY2 ? lineY2 * strokeHeight : lineY2, stroke: strokeColor, strokeWidth: secondary ? 1 : 1.5, style: style }), !secondary && ((0, jsx_runtime_1.jsx)("text", { x: textX1, y: textY1, textAnchor: anchor, dominantBaseline: dominantBaseline, style: labelStyle, children: children }))] }));
}
exports.Tick = Tick;
