"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.usePan = void 0;
const react_1 = require("react");
const plotControllerContext_1 = require("../contexts/plotController/plotControllerContext");
function usePan(options = {}) {
    const { horizontalAxisId = 'x', verticalAxisId = 'y' } = options;
    const click = (0, react_1.useRef)(false);
    const plotControls = (0, plotControllerContext_1.usePlotControls)(options);
    // TODO : cursor state
    // const [cursor, setCursor] = useState<'' | 'grabbing' | 'grab'>('');
    (0, plotControllerContext_1.usePlotEvents)({
        // onKeyDown({ event: { altKey } }) {
        //   if (altKey) {
        //     setCursor('grab');
        //   }
        // },
        // onKeyUp({ event: { altKey } }) {
        //   if (!altKey) {
        //     setCursor('');
        //   }
        // },
        onPointerDown() {
            // if (altKey) {
            //   setCursor('grabbing');
            // }
            click.current = true;
        },
        onPointerUp() {
            // if (altKey) {
            //   setCursor('grab');
            // }
            click.current = false;
        },
        onPointerMove({ event: { altKey }, movement: { [horizontalAxisId]: xMovement, [verticalAxisId]: yMovement, }, domains: { [horizontalAxisId]: x, [verticalAxisId]: y }, }) {
            if (!click.current || !altKey)
                return;
            plotControls.setAxes({
                [horizontalAxisId]: {
                    min: x[0] - xMovement,
                    max: x[1] - xMovement,
                },
                [verticalAxisId]: {
                    min: y[0] - yMovement,
                    max: y[1] - yMovement,
                },
            });
        },
        onDoubleClick({ event: { button } }) {
            if (button !== 0)
                return;
            plotControls.resetAxes([horizontalAxisId, verticalAxisId]);
        },
    }, options);
}
exports.usePan = usePan;
